
#define HT1632_READ	0xC0	// 110 A6A5A4A3A2A1A0D0D1D2D3 Read data from the RAM
#define HT1632_WRITE	0xA0	// 101 A6A5A4A3A2A1A0D0D1D2D3 Write data to the RAM
#define HT1632_RDMODWR	0xA0	// 101 A6A5A4A3A2A1A0D0D1D2D3 Read and Write data to the RAM
#define HT1632_CMD	0x80	// 100
#define HT1632_CMD_SYS_DIS	0x00	// 0000-0000-X Turn off both system oscillator and LED duty cycle generator
#define HT1632_CMD_SYS_EN	0x01	// 0000-0001-X Turn on system oscillator
#define HT1632_CMD_LED_OFF	0x02	// 0000-0010-X Turn off LED duty cycle generator
#define HT1632_CMD_LED_ON	0x03	// 0000-0011-X Turn on LED duty cycle generator
#define HT1632_CMD_BLINK_OFF	0x08	// 0000-1000-X Turn off blinking function
#define HT1632_CMD_BLINK_ON	0x09	// 0000-1001-X Turn on blinking function
#define HT1632_CMD_SLAVE_MODE	0x10	// 0001-00XX-X Set slave mode and clock source from external clock
#define HT1632_CMD_MASTER_MODE	0x14	// 0001-01XX-X Set master mode and clock source on-chip RC oscillator, the system clock output to OSC pin
#define HT1632_CMD_CLK_RC	0x18	// 0001-10XX-X System clock source, on-chip RC oscillator
#define HT1632_CMD_CLK_EXT	0x1C	// 0001-11XX-X System clock source, external clock source
#define HT1632_CMD_COM_OPT	0x20	// 0010-abXX-X
#define HT1632_CMD_COM_OPT_N8		0x20	// ab=00: N-MOS open drain output and 8 common option
#define HT1632_CMD_COM_OPT_N16		0x24	// ab=01: N-MOS open drain output and 16 common option
#define HT1632_CMD_COM_OPT_P8		0x28	// ab=10: P-MOS open drain output and 8 common option
#define HT1632_CMD_COM_OPT_P16		0x2C	// ab=11: P-MOS open drain output and 16 common option						
#define HT1632_CMD_PWM_DUTY	0xA0	// 101X-dcba-X PWM , dcba = (x+1)/16 duty

uint8_t HT1632_read(uint8_t address);
void HT1632_write(uint8_t address,uint8_t data);
void HT1632_command(uint8_t cmd);
void HT1632_readbytes(uint8_t *address,uint8_t num);
void HT1632_writebytes(uint8_t *address,uint8_t num);
void init_HT1632(void);
void HT1632_fill(uint8_t pattern);
#define HT1632_cls() HT1632_fill(0)	
#define HT1632_setPWM(level) 	HT1632_command(HT1632_CMD_PWM_DUTY | level)
void HT1632_string(uint8_t address,char *string);
